//
//  CS52_5_4132_1230718_AshleyZeldin
//
//  Ashley Zeldin
//  CS 52 Section 4132
//  October 10, 2015
//
//  Pen.cpp
//

#include <iostream>
#include <string>
#include <unistd.h>
#include "Pen.h"

namespace CS52
{
//Constructors
    
    //Construct a generic pen without brand, type or even color.
    Pen::Pen()
    {
        hasBrand = false;
        hasType = false;
        hasColor = false;
        
        penCapOn = true;
        
        std::cout << "Splendid! A pen has been created especially for you." << std::endl << std::endl;
    }
    
/*
    //Construct a less generic pen without brand or type, but with a vibrant color.
    Pen::Pen(std::string color)
    {
        if (isValidAttribute('c', color))
        {
            penColor = color;
        }
        else
        {
            std::cout << "Allow me to choose a color for you." << std::endl;
            randomPen('c');
        }
        
        hasColor = true;
        
        hasBrand = false;
        hasType = false;
        
        penCapOn = true;
        
        std::cout << "One moment while I create your pen." << std::endl << std::endl;
        
        sleep(1);
        
        std::cout << "Splendid! A " << penColor << " pen has been created especially for you." << std::endl << std::endl;
    }
 
    //Construct a more particular pen of a certain brand and type without specifying color.
    Pen::Pen(std::string brand, std::string type)
    {
        //Set brand attribute to user input; if empty string, hasn't been input.
        if (brand != "")
        {
            if (isValidAttribute('b', brand))
            {
                penBrand = brand;
            }
            else
            {
                std::cout << "Allow me to choose a brand for you." << std::endl;
                randomPen('b');
            }

            hasBrand = true;
        }
        else
        {
            hasBrand = false;
        }
        
        if (type != "")
        {
            if (isValidAttribute('t', type))
            {
                penType = type;
            }
            else
            {
                std::cout << "Allow me to choose a type for you." << std::endl;
                randomPen('t');
            }

            hasType = true;
        }
        else
        {
            hasType = false;
        }
        
        hasColor = false;
        
        penCapOn = true;
        
        std::cout << "One moment while I create your pen." << std::endl << std::endl;
        
        sleep(1);
        
        std::cout << "Splendid! A " << penBrand << " " << type << " pen has been created especially for you." << std::endl << std::endl;
    }
*/
 
    //Construct a pen exactly as the user specifies, potentially with a certain brand and type, and color.
    Pen::Pen(std::string brand, std::string type, std::string color)
    {
        //As long as each property isn't an empty string.
        if (brand != "" && type != "" && color != "")
        {
            std::cout << "Impressive. You truly do know what you want. I rather respect that about you." << std::endl << std::endl;
        }
        
        sleep(1);
        
        //Set brand attribute to user input; if empty string, hasn't been input.
        if (brand != "")
        {
            //If brand is valid.
            if (isValidAttribute('b', brand))
            {
                //Set pen brand.
                penBrand = brand;
            }
            else
            {
                //Select random brand.
                randomPen('b');
            }
            
            hasBrand = true;
        }
        else
        {
            hasBrand = false;
        }
        
        //Set type attribute to user input; if empty string, hasn't been input.
        if (type != "")
        {
            //If type is valid.
            if (isValidAttribute('t', type))
            {
                //Set pen type.
                penType = type;
            }
            else
            {
                //Set random type.
                randomPen('t');
            }
            
            hasType = true;
        }
        else
        {
            hasType = false;
        }
        
        //Set color attribute to user input; if empty string, hasn't been input.
        if (color != "")
        {
            //If color is valid.
            if (isValidAttribute('c', color))
            {
                //Set pen color.
                penColor = color;
            }
            else
            {
                //Set random color.
                randomPen('c');
            }

            hasColor = true;
        }
        else
        {
            hasColor = false;
        }
        
        //Pen cap is on initially.
        penCapOn = true;
    
        std::cout << "One moment while I create your pen." << std::endl << std::endl;
        
        sleep(1);
        
        std::cout << "Splendid! ";
        
        //If pen has defined color, handle output.
        if (hasColor)
        {
            if (penColor == "orange")
            {
                std::cout << "An ";
            }
            else
            {
                std::cout << "A ";
            }
            std::cout << penColor << " ";
        }
        else
        {
            std::cout << "A ";
        }
        
        if (hasBrand)
        {
            std::cout << penBrand << " ";
        }
        
        if (hasType)
        {
            std::cout << penType << " ";
        }
        
        std::cout <<"pen has been created especially for you." << std::endl << std::endl;
    }
    
//Arrays
    
    //A chart of boolean values representing possible pen brand and type combinations, where rows and columns signify brands and types, respectively.
    bool penChart[7][4] =
    {
        {true, true, true, true},
        {false, true, false, false},
        {true, false, true, false},
        {true, true, true, true},
        {true, true, true, true},
        {false, false, true, true},
        {true, true, true, true}
    };
    
    //An array of possible pen brands.
    std::string penBrands[] = {"Bic", "Montblanc", "Paper Mate", "Pentel", "Pilot", "Uni-ball", "Zebra"};
    //To determine length of penBrands array, divide size of array in bytes by the size of an individual element.
    int numPenBrands = sizeof(penBrands)/sizeof(penBrands[0]);
    
    //An array of possible pen types.
    std::string penTypes[] = {"ballpoint", "fountain", "gel", "rollerball"};
    //To determine length of penTypes array, divide size of array in bytes by the size of an individual element.
    int numPenTypes = sizeof(penTypes)/sizeof(penTypes[0]);

    //An array of possible pen colors.
    std::string penColors[] = {"black", "blue", "red", "purple", "green", "pink", "orange"};
    //To determine length of penColors array, divide size of array in bytes by the size of an individual element.
    int numPenColors = sizeof(penColors)/sizeof((penColors[0]));
    
//Setters
    
    //
    //Function: void Pen::setBrand(std::string brand); void Pen::setType(std::string type) void Pen::setColor(std::string color)
    //Purpose: To set the brand, type and color of the pen, respectively, and output to user.
    //Parameters: std::string brand; std::string type; std::string color
    //Return: N/A
    //Input: N/A
    //Output: Regurgitates set brand, type and color, respectively.
    //
    
    void Pen::setBrand(std::string brand)
    {
        penBrand = brand;
        hasBrand = true;
        
        std::cout << "You have selected a " << penBrand << " pen with which to write. Quite the stylish choice!" << std::endl << std::endl;
    }
    
    void Pen::setType(std::string type)
    {
        penType = type;
        hasType = true;
        
        std::cout << "You have selected a " << penType << " pen with which to write. Such lovely crafted lines!" << std::endl << std::endl;
    }
    
    void Pen::setColor(std::string color)
    {
        penColor = color;
        hasColor = true;
        
        if (color == "orange")
        {
            std::cout << "You have selected an " << penColor << " pen with which to write. What a vibrant color!" << std::endl << std::endl;
        }
        else
        {
            std::cout << "You have selected a " << penColor << " pen with which to write. What a vibrant color!" << std::endl << std::endl;
        }
    }
    
//Getters
    
    //
    //Function: bool Pen::doesPenExist()
    //Purpose: To check whether currently configured pen exists.
    //Parameters: N/A
    //Return: The boolean variable penExists tracks whether the pen as currently configured exists.
    //Input: N/A
    //Output: Lets user know whether currently configured pen exists, displaying tailored error messages where necessary to inform user that combination isn't possible, or that not all properties have been configured.
    //
    
    bool Pen::doesPenExist()
    {
        bool foundBrand = false;
        bool foundType = false;
        bool penExists = false;
        
        if(hasBrand && hasType && hasColor)
        {
            //Keep track of the index of the array where pen brand and type are found.
            int brandIndex = 0;
            int typeIndex = 0;
            
            for (int i = 0; i < numPenBrands; i++)
            {
                if (penBrand == penBrands[i])
                {
                    foundBrand = true;
                    brandIndex = i;
                }
            }
            
            for (int j = 0; j < numPenTypes; j++)
            {
                if (penType == penTypes[j])
                {
                    foundType = true;
                    typeIndex = j;
                }
            }
            
            //Pen exists in that type but not by that brand.
            if (foundBrand == false && foundType == true)
            {
                std::cerr << "Unfortunately, I do not possess a pen of your desired brand in any type. Perhaps you might try another brand?" << std::endl;
            }
            //Pen exists by that brand but not in that type.
            else if (foundType == false && foundBrand == true)
            {
                std::cerr << "Unfortunately, I do not possess a pen of your desired type by any brand. Perhaps you might try another type?" << std::endl;
            }
            //Pen brand and type both not found.
            else if (foundBrand == false && foundType == false)
            {
                std::cerr << "I'm terribly sorry, but I possess neither your desired pen brand nor your desired pen type. Why don't you choose another?" << std::endl;
            }
            //Pen brand and type combination found.
            else if (penChart[brandIndex][typeIndex] == true)
            {
                penExists = true;
                std::cout << "My, what a delightful pen you have chosen to compose your letter!" << std::endl;
            }
            //Pen brand and type combination not found.
            else
            {
                std::cerr << "I have a quandary; I possess pens by your desired brand and in your desired type, but not in that combination. Why don't you choose another?" << std::endl;
            }
        }
        
        //Output error message to user noting that brand, type or color hasn't been selected.
        if (!hasBrand)
        {
            std::cerr << "It appears you haven't chosen a pen (b)rand. Please do make a selection." << std::endl;
        }
        if (!hasType)
        {
            std::cerr << "It appears you haven't chosen a pen (t)ype. Please do make a selection." << std::endl;
        }
        if (!hasColor)
        {
            std::cerr << "It appears you haven't chosen a pen (c)olor. Please do make a selection." << std::endl;
        }

        return penExists;
    }
    
    //
    //Function: std::string Pen::getColor(); std::string Pen::getBrand(); std::string Pen::getType()
    //Purpose: To get the brand, type and color of the pen, respectively, and return to driver.
    //Parameters: N/A
    //Return: The functions return penColor, penBrand and penType, respectively.
    //Input: N/A
    //Output: N/A
    //
    
    std::string Pen::getColor()
    {
        return penColor;
    }
    
    std::string Pen::getBrand()
    {
        return penBrand;
    }
    
    std::string Pen::getType()
    {
        return penType;
    }
    
//Modifiers
    
    //
    //Function: void Pen::uncap()
    //Purpose: To remove the pen cap so that the pen is able to write.
    //Parameters: N/A
    //Return: N/A
    //Input: N/A
    //Output: Displays a confirmation message if removal of pen cap was successful or an error message if pen cap wasn't able to be removed since it already had been removed.
    //
    
    void Pen::unCap()
    {
        if (penCapOn)
        {
            std::cout << std::endl << "The pen is poised and ready for writing for you have removed the pen cap. I most eagerly await your instructions." << std::endl;
         
            //Change state of pen cap to off.
            penCapOn = false;
        }
        else
        {
            std::cerr << std::endl << "So sorry, I am unable to remove the pen cap, as the pen is already uncapped. Perhaps you intended to re(p)lace the pen cap instead?" << std::endl;
        }

    }
    
    //
    //Function: Pen::write(std::string message)
    //Purpose: To write--that is, display--a message with the pen.
    //Parameters: std::string message
    //Return: N/A
    //Input: N/A
    //Output: Displays the message passed as parameter, in addition to the specifics of the pen used in the writing of the message.
    //
    
    void Pen::write(std::string message)
    {
        //If pen cap is still on.
        if (penCapOn)
        {
            //Display error message indicating inability to write.
            std::cerr << std::endl << "My apologies. The pen is not writing-ready, as its cap is intact. Kindly re(m)ove the pen cap before proceeding." << std::endl;
        }
        //Otherwise, output the message, including a description of the pen currently in use.
        else
        {
            std::cout << "The " ;
            
            if (hasColor)
            {
                std::cout << penColor << " ";
            }
            if (hasBrand)
            {
                std::cout << penBrand << " ";
            }
            if (hasType)
            {
                std::cout << penType << " ";
            }
            if (!hasColor && !hasBrand && !hasType)
            {
                std::cout << "unspecified ";
            }
            
            std::cout << "pen is writing the following message: " << message << std::endl;
        }
    }
    
    //
    //Function: void Pen::reCap()
    //Purpose: To replace the pen cap after the pen has been used.
    //Parameters: N/A
    //Return: N/A
    //Input: N/A
    //Output: Displays a confirmation message if replacement of pen cap was successful or an error message if pen cap wasn't able to be replaced since it already had been replaced.
    //
    
    void Pen::reCap()
    {
        if (penCapOn)
        {
            std::cerr << std::endl << "So sorry, I am unable to replace the pen cap, as the pen is already capped. Perhaps you intended to re(m)ove the pen cap instead?" << std::endl;
        }
        else
        {
            std::cout << std::endl << "Done already? You have replaced the pen cap, so I wonder if you have derived ample use from your pen?" << std::endl;
            penCapOn = true;
        }
    }
    
    //
    //Function: bool Pen::isCapOn()
    //Purpose: To discern whether or not the pen is capped.
    //Parameters: N/A
    //Return: Returns a boolean variable indicating the state of the pen cap.
    //Input: N/A
    //Output: N/A
    //
    bool Pen::isCapOn()
    {
        return penCapOn;
    }
    
    //
    //Function: bool Pen::hasProperty(char property)
    //Purpose: To check whether a specific property--brand, type or color--has been set for the pen currently in use.
    //Parameters: char(property)
    //Return: Returns a boolean variable--hasBrand, hasType or hasColor, respectively--indicating whether the pen has a set value for the property being checked.
    //Input: N/A
    //Output: Displays an error message if passed parameter does not correspond to a property.
    //
    
    bool Pen::hasProperty(char property)
    {
        if (property == 'b')
        {
            return hasBrand;
        }
        else if (property == 't')
        {
            return hasType;
        }
        else if (property == 'c')
        {
            return hasColor;
        }
        else
        {
            std::cerr << std::endl << "Unfortunately, I am unable to comprehend your request. " << std::endl;
            return false;
        }
    }
    
    //
    //Function: Pen::isValidAttribute(char property, std::string valueToCheck)
    //Purpose: To discern whether the string input for a given property--brand, type or color--is valid.
    //Parameters: char property, std::string valueToCheck
    //Return: Returns a boolean variable isFound indicating whether the property being checked is in the list of valid members.
    //Input: N/A
    //Output: Displays an error message if character input passed as parameter doesn't correspond to a property or if brand, type or color is not available.
    //
    
    bool Pen::isValidAttribute(char property, std::string valueToCheck)
    {
        //Declare boolean variable to handle search and initialize to false.
        bool isFound = false;
        
        //Declare string variable to handle output of attribute.
        std::string attribute;
        
        //If checking brand.
        if (property == 'b')
        {
            attribute = "brand";
            
            //Parse array to compare user input to valid members.
            for (int i = 0; i < numPenBrands; i++)
            {
                //If found.
                if (valueToCheck == penBrands[i])
                {
                    isFound = true;
                }
            }
        }
        //If checking type.
        else if (property == 't')
        {
            attribute = "type";
            
            //Parse array to compare user input to valid members.
            for (int i = 0; i < numPenTypes; i++)
            {
                //If found.
                if (valueToCheck == penTypes[i])
                {
                    isFound = true;
                }
            }
        }
        //If checking color.
        else if (property == 'c')
        {
            attribute = "color";
            
            //Parse array to compare user input to valid members.
            for (int i = 0; i < numPenColors; i++)
            {
                //If found.
                if (valueToCheck == penColors[i])
                {
                    isFound = true;
                }
            }
        }
        //If character input doesn't correspond to property.
        else
        {
            std::cerr << std::endl << "Unfortunately, I am unable to comprehend your request. " << std::endl;
            return isFound;
        }
        
        //If string input isn't found in array, display error message.
        if (!isFound)
        {
            std::cerr << "Oh, bother. I beg your pardon. I do not carry that " << attribute << ". May I select a suitable substitute?" << std::endl << std::endl;
        }
        
        return isFound;
    }

    //
    //Function: Pen::randomPen()
    //Purpose: To create a pen at random, from available brands and types--checking against array of valid combinations of brands and types--as well as colors.
    //Parameters: N/A
    //Return: N/A
    //Input: N/A
    //Output: Lets user know a random pen will be chosen, and informs user when creation is complete.
    //
    
    void Pen::randomPen()
    {
        //Repeat indefinitely.
        while (true)
        {
            //Select brand, type and color at random.
            int brand = random() % numPenBrands;
            int type = random() % numPenTypes;
            int color = random() % numPenColors;
            
            //If, according to chart of potential brand and type combinations, the randomly selected combination is possible, use corresponding brand and type for writing; also assign color chosen at random according to array of potential colors.
            if (penChart[brand][type])
            {
                penBrand = penBrands[brand];
                penType = penTypes[type];
                penColor = penColors[color];
                
                //Set flag indicating that pen has a particular property to true.
                hasBrand = true;
                hasType = true;
                hasColor = true;
                
                std::cout << "As you have not selected a particular pen, I will choose one for you. One moment while I create your pen." << std::endl;
                
                sleep(1);
                
                std::cout << "Aha! There we are. You have a pen. " << std::endl << std::endl;
                
                //Break out of infinite loop when suitable combination of brand and type found.
                break;
            }
        }
    }
    
    //
    //Function: Pen::randomPen(char property)
    //Purpose: To randomize one or two missing pen properties, using list of available brands and types--checking against array of valid combinations of brands and types--as well as colors.
    //Parameters: char property
    //Return: N/A
    //Input: N/A
    //Output: N/A
    //
    
    void Pen::randomPen(char property)
    {
        //If brand.
        if (property == 'b')
        {
            //Repeat indefinitely.
            while (true)
            {
                //Randomly select brand from array.
                int brand = random() % numPenBrands;
                //If type not specified.
                if (!hasType)
                {
                    //Assign brand chosen at random according to array of potential brands.
                    penBrand = penBrands[brand];
                    
                    //Escape loop.
                    break;
                }
                //Otherwise, find specified type.
                else
                {
                    //Initialize to zero so the compiler won't complain.
                    int type = 0;
                    
                    for (int i = 0; i < numPenTypes; i++)
                    {
                        if (penType == penTypes[i])
                        {
                            type = i;
                        }
                    }
                    
                    //Parse array to ensure brand and type match.
                    if (penChart[brand][type])
                    {
                        penBrand = penBrands[brand];
                        
                        //Break out of infinite loop when suitable combination of brand and type found.
                        break;
                    }
                }
            }
            
            //Set flag indicating that pen has a particular property to true.
            hasBrand = true;
        }
        //If type.
        else if (property == 't')
        {
            //Repeat indefinitely.
            while (true)
            {
                //Randomly select type from array.
                int type = random() % numPenTypes;
                
                //If brand not specified.
                if (!hasBrand)
                {
                    //Assign type chosen at random according to array of potential types.
                    penType = penTypes[type];
                    
                    //Escape loop.
                    break;
                }
                //Otherwise, find specified brand.
                else
                {
                    //Initialize to zero so the compiler won't complain.
                    int brand = 0;
                    
                    for (int i = 0; i < numPenBrands; i++)
                    {
                        if (penBrand == penBrands[i])
                        {
                            brand = i;
                        }
                    }
                    
                    //Parse array to ensure brand and type match.
                    if (penChart[brand][type])
                    {
                        penType = penTypes[type];
                        
                        //Break out of infinite loop when suitable combination of brand and type found.
                        break;
                    }
                }
            }
            
            //Set flag indicating that pen has a particular property to true.
            hasType = true;
        }
        //If color.
        else if (property == 'c')
        {
            //Randomly select color from array.
            int color = random() % numPenColors;
            
            //Assign color chosen at random according to array of potential colors.
            penColor = penColors[color];
            
            //Set flag indicating that pen has a particular property to true.
            hasColor = true;
        }
    }
    
    //
    //Function: Pen::describePen()
    //Purpose: To display a description of the current pen, including brand, type and color, if specified, whether by user or randomization.
    //Parameters: N/A
    //Return: N/A
    //Input: N/A
    //Output: Tells the user about the brand, type and color, if specified, of the pen currently in use.
    //
    
    void Pen::describePen()
    {
        //if any parameters set, display those and prompt for the rest
        //if no parameters set, error
        
        std::cout << std::endl << "You are currently using ";

        //If no properties set, refer to pen as unspecified.
        if (!hasBrand && !hasType && !hasColor)
        {
            std::cout << "an unspecified pen." << std::endl;
        }
        //Otherwise, list known properties.
        else
        {
            std::cout << "a ";
            
            if (hasColor)
            {
                std::cout << penColor << " ";
            }
            
            if (hasType)
            {
                std::cout << penType << " ";
            }
            
            std::cout << "pen";
            
            if (hasBrand)
            {
                std::cout << " by " << penBrand;
            }
            
            std::cout << ". Excellent choice, if I do say so myself." << std::endl;
        }
    }
    
    //
    //Function: Pen::quitPen()
    //Purpose: To exit the letter-writing program.
    //Parameters: N/A
    //Return: N/A
    //Input: N/A
    //Output: Displays either a goodbye--if pen is capped--or a request for the user to replace the pen cap before trying to quit.
    //
    
    void Pen::quitPen()
    {
        //If pen is capped.
        if (isCapOn())
        {
            std::cout << std::endl << "Thank you for your continued patronage of your humble letter-writer. I do hope you have a pleasant evening.";

            //Exit program.
            exit(1);
        }
        //If pen isn't capped.
        else
        {
            std::cout << std::endl << "Mind re(p)lacing the pen cap before quitting your humble letter-writer?";
        }
    }
}
