//
//  CS52_5_4132_1230718_AshleyZeldin
//
//  Ashley Zeldin
//  CS 52 Section 4132
//  October 10, 2015
//
//  Pen.h
//

#ifndef CS52_6_4132_1230718_AshleyZeldin_Pen_h
#define CS52_6_4132_1230718_AshleyZeldin_Pen_h

#include <iostream>
#include <string>

namespace CS52
{
    class Pen
    {
    public:
        
    //Constructors
        
        //When you simply can't be fussed.
        Pen();

/*
        //When you can't be fussed with particular brands and types.
        Pen(std::string color);
        
        //When you can't be fussed with whimsical colors.
        Pen(std::string brand, std::string type);
*/

        //When you can be fussed.
        Pen(std::string brand, std::string type, std::string color);
        
    //Setters
        
        //Desired brand.
        void setBrand(std::string brand);
        //Desired type.
        void setType(std::string type);
        //Desired color.
        void setColor(std::string color);
        
    //Getters
        
        //What color is the pen?
        std::string getColor();
        //What brand is the pen?
        std::string getBrand();
        //What type is the pen?
        std::string getType();
        
        //Given brand and type, does such a pen even exist?
        bool doesPenExist();
        
        //Detecting whether the pen is primed for writing.
        bool isCapOn();
        
        //Determining whether (b)rand, (t)ype and (c)olor property already set.
        bool hasProperty(char property);
        
        //Determining whether (b)rand, (t)ype and (c)olor value is valid.
        bool isValidAttribute(char property, std::string valueToCheck);

    //Modifiers
        
        //Readying the pen for writing.
        void unCap();
        
        //Write already!
        void write(std::string message);
        
        //Putting the pen away.
        void reCap();
        
        //Random pen selector.
        void randomPen();

        //Random attribute selector.
        void randomPen(char property);

        //What is the pen like?
        void describePen();
        
        //Exit.
        void quitPen();
    
    private:
        
        std::string penBrand;
        std::string penType;
        std::string penColor;

        bool hasBrand;
        bool hasType;
        bool hasColor;
        
        bool penCapOn;
    };
}

#endif
