//
//  CS52_6_4132_1230718_AshleyZeldin
//
//  Ashley Zeldin
//  CS 52 Section 4132
//  October 10, 2015
//
//  Purpose: To create a pen with unique attributes such as brand, type and color that the letter-writer--a character embodied by the program--will use to write messages.
//  Input: Program accepts user input of brand, type and color for constructors; character input for option selection; string input for the message to be written.
//  Output: Program interacts with user, outputting options for the user and results of user input, i.e. talking the user through the process of creating the pen, describing the pen when the option is chosen, displaying the text entered by the user.
//  Note: I decided to treat this assignment as a text adventure! I like to have fun with my homework, if you haven't noticed. Also, I used some concepts from chapter 9, new and delete, to make a new Pen object pointer without really constructing the pen 'til the arguments to the constructor are determined by user input that I later delete when the Pen object is actually created (just like malloc and free in C!). If only I could get the console to output in colors like I did in CS 50!
//

#include <iostream>
#include <string>
#include <unistd.h>
#include "Pen.h"

using namespace CS52;

int main()
{
    //Seed random number generator; cast return value of time function to integer to eliminate compiler warning.
    srandom((int) time(NULL));
    
    //ASCII art, of course.
    std::string letterWriter =  "     /     ___  ____  ____  ___  ___  /      /  ___   ____  ____  ___  ___  \n"
                                "    /     /      /     /   /    /   | |  /  |  /   |   /     /   /    /   | \n"
                                "   /     /__    /     /   /__  /___/  / /| /  /___/   /     /   /__  /___/  \n"
                                "  /     /      /     /   /    /  \\    |/  |  /  \\    /     /   /    /  \\    \n"
                                " /___  /___   /     /   /___ /   /    /   / /   / __/__   /   /___ /   /    \n";
    
    std::cout << letterWriter << std::endl;
    
    sleep(1);
    
    std::cout << "Salutations! I, your humble letter-writer, am a participative interaction--no, not even an artificial intelligence, I'm afraid--so I must apologize if you were expecting a simpler--or more complex--experience. Thank you in advance for your willing cooperation." << std::endl << std::endl;
    
    sleep(5);
    
    std::cout << "Now, where was I? Oh I know! I presume you would like to create a pen." << std::endl << std::endl;
    
    sleep(2);
    
    //Prompt user to create a pen, with or without specific arguments to pass to constructor function.
    std::cout << "First and foremost, have you already decided on the brand, type and color specifications of the pen you would like to use? Is that a (y)es or a (n)o? You may also answer (y)es if you prefer a particular brand and type of pen but have not yet settled on a color, or if you are adamant about the color only." << std::endl;
    
    //Declaration of character variable to handle yes or no selection by user, initialized to whitespace character.
    char isYorN = ' ';
    
    //Declaration of a pointer to a Pen object that I initialize to NULL, to allocate memory for a Pen object without yet calling the constructor for it. Thanks chapter 9!
    Pen * pointerP = NULL;
    
    do
    {
        //Accept user input, yes or no.
        std::cin >> isYorN;
        
        //Flush buffer. A bit more verbose than fflush from C.
        std::cin.clear();
        std::cin.ignore(INT_MAX, '\n');
        
        //If input is anything other than y, Y, n or N, prompt user again.
        if (isYorN != 'y' && isYorN != 'Y' && isYorN != 'n' && isYorN != 'N')
        {
            std::cerr << "Please answer (y)es if you have a brand, type and color of pen already in mind; otherwise, if you would like assistance, please answer (n)o.";
        }
        
        //If user has preferences, prompt and pass as arguments to constructor function to construct Pen object with those attributes.
        if (isYorN == 'y' || isYorN == 'Y')
        {
            //Declare variables to hold brand, type and color to pass as arguments to Pen object constructor.
            std::string brand;
            std::string type;
            std::string color;
            
            std::cout << std::endl << "You are decisive then, it would appear. I quite like that." << std::endl << std::endl;
            
            sleep(1);
            
            //Prompt for brand, type and color, and accept user input of string, using getline in order to accept multiple words.
            std::cout << "May I enquire as to your desired brand of pen? If you haven't a preference after all, please press (enter) only." << std::endl;
            std::getline(std::cin, brand);
            std::cout << "May I enquire as to your desired type of pen? If you haven't a preference after all, please press (enter) only." << std::endl;
            std::getline(std::cin, type);
            std::cout << "May I enquire as to your desired color of pen? If you haven't a preference after all, please press (enter) only." << std::endl;
            std::getline(std::cin, color);
            
            //As long as brand, type and color aren't empty strings.
            if (brand != "" || type != "" || color != "")
            {
                //Construct a new Pen object with brand, type and color arguments, and set pointer to the newly constructed object.
                pointerP = new Pen(brand, type, color);
            }
/*            //Otherwise, as long as brand and type aren't empty strings.
            else if (brand != "" && type != "")
            {
                //Construct a new Pen object with brand and type arguments, and set pointer to the newly constructed object.
                pointerP = new Pen(brand, type);
            }
            //Otherwise, if only brand is specified along with color.
            else if (brand != "" && color != "")
            {
                //Construct a new Pen object with brand argument and empty type argument, and set pointer to the newly constructed object; if color specified, pass as argument as well.
                pointerP = new Pen(brand, "");
                pointerP->setColor(color);
            }
            //Otherwise, if only type is specified along with color.
            else if (type != "" && color != "")
            {
                //Construct a new Pen object with empty brand argument and type argument, and set pointer to the newly constructed object; if color specified, pass as argument as well.
                pointerP = new Pen("", type);
                pointerP->setColor(color);
            }
            //Otherwise, if only color is specified.
            else if (color != "")
            {
                //Construct a new Pen object with color argument only, and set pointer to the newly constructed object.
                pointerP = new Pen(color);
            }
*/
            else
            {
                std::cout << "I see. Not to worry; there is no shame in not knowing what you want. One moment while I create your pen." << std::endl << std::endl;
                
                sleep(1);
                
                //Construct a new generic Pen object with no arguments, and set pointer to the newly constructed object.
                pointerP = new Pen();
            }
        }
            
        //If user has no preferences, construct a new generic Pen object, and set pointer to the newly constructed object.
        else if (isYorN == 'n' || isYorN == 'N')
        {
            std::cout << "I see. Not to worry; there is no shame in not knowing what you want. One moment while I create your pen." << std::endl << std::endl;
            
            sleep(1);
            
            pointerP = new Pen();
        }
        
    //Repeat prompt as long as user input isn't y, Y, n or N.
    }while (isYorN != 'y' && isYorN != 'Y' && isYorN != 'n' && isYorN != 'N');
    
    //Thanks chapter 9!
    Pen p = * pointerP;
    
    //Delete the pointer since the Pen object has been created.
    delete pointerP;
    
    sleep(2);
    
    //List available commands.
    std::cout << "As your letter-writer, I am capable of understanding the following commands:" << std::endl << "* selecting the desired (b)rand, (t)ype and (c)olor of your ideal pen;" << std::endl << "* re(m)oving or re(p)lacing the cap of your pen;" << std::endl << "* (w)riting with your pen;" << std::endl << "* (l)isting available commands;" << std::endl << "* creating a (n)ew pen;"<< std::endl << "* (q)uitting the program." << std::endl << "For simplicity's sake, please type only the letter indicated to complete your request. " << std::endl << std::endl;
   
    //Prompt for choice of command.
    std::cout << "Please indicate your choice now: ";
    
    //Keep running switch statement indefinitely.
    while (true)
    {
        //Declare character variable to handle user input for switch statement containing commands.
        char choice;
        //Declare character variable to handle user input for switch statement containing colors.
        char colorChoice;
        
        //Accept user input of character variable.
        std::cin >> choice;
        //Clear buffer.
        std::cin.clear();
        std::cin.ignore(INT_MAX, '\n');
        
        //Declare a boolean variable to verify whether command is valid, and initialize to true.
        bool understandCommand = true;
        
        switch (choice)
        {
            //Brand.
            case 'b':
            {
                //Prompt for user input of brand.
                //    std::string penBrands[] = {"Bic", "Montblanc", "Paper Mate", "Pentel", "Pilot", "Uni-ball", "Zebra"};
                std::cout << std::endl << "Do tell me your desired brand of pen. Perhaps you would prefer a Bic or Montblanc? You might try a Uni-ball or Zebra? You also have the option of a Paper Mate, Pentel or Pilot pen." << std::endl;
               
                //Declare string variable to handle user input of brand.
                std::string brand;
                
                //Accept user input of string, using getline in order to accept multiple words.
                std::getline(std::cin, brand);
                
                //Check if brand input is valid.
                if (p.isValidAttribute('b', brand))
                {
                    //If so, set the brand of pen.
                    p.setBrand(brand);
                    
                    //If user also input a type.
                    if (p.hasProperty('t'))
                    {
                        //Check whether combination exists.
                        p.doesPenExist();
                    }
                }
                
                break;
            }

            //Type
            case 't':
            {
                //Prompt for user input of type.
                //    std::string penTypes[] = {"ballpoint", "fountain", "gel", "rollerball"};
                std::cout << std::endl << "Do tell me your desired type of pen. Would you like, for instance, a ballpoint pen or a fountain pen?" << std::endl;
                
                //Declare string variable to handle user input of type.
                std::string type;
                
                //Accept user input of string, using getline in order to accept multiple words.
                std::getline(std::cin, type);
                
                //Check if type input is valid.
                if (p.isValidAttribute('t', type))
                {
                    //If so, set the type of pen.
                    p.setType(type);
                    
                    //If user also input a type.
                    if (p.hasProperty('b'))
                    {
                        //Check whether combination exists.
                        p.doesPenExist();
                    }
                }
                
                break;
            }
            
            //Color.
            case 'c':
            {   //    std::string penColors[] = {"black", "blue", "red", "purple", "green", "pink", "orange"};
                
                //Prompt for pen color.
                std::cout << std::endl << "Do tell me your desired color of pen. I can offer you a wide variety of colors, you know. You may choose amongst blac(k), (b)lue, (r)ed, (p)urple, (g)reen, pi(n)k and (o)range!" <<std::endl << std::endl;
                
                std::cout << "Please indicate your choice by simply entering the letter corresponding to your desired color: ";
                //std::cout << "Please select a color from the list above: ";
                
                //Accept input of color from user.
                std::cin >> colorChoice;
                
                //Clear buffer.
                std::cin.clear();
                std::cin.ignore(INT_MAX, '\n');
                
                //Declare a string to handle display of color.
                std::string colorName;
                
                //Handle user input and display color.
                
                switch (colorChoice)
                {
                    //A black pen.
                    case 'k':
                    {
                        //Set color name.
                        colorName = "black";
                        
                        //set pen color.
                        p.setColor(colorName);
                        
                        break;
                    }
                        
                    //A blue pen.
                    case 'b':
                    {
                        //Set color name.
                        colorName = "blue";
                        
                        //Set pen color.
                        p.setColor(colorName);
                        
                        break;
                    }
                        
                    //A red pen.
                    case 'r':
                    {
                        //Set color name.
                        colorName = "red";
                        
                        //Set pen color.
                        p.setColor(colorName);
                        
                        break;
                    }
                        
                    //A purple pen.
                    case 'p':
                    {
                        //Set color name.
                        colorName = "purple";
                        
                        //Set pen color.
                        p.setColor(colorName);
                        
                        break;
                    }
                        
                    //A green pen.
                    case 'g':
                    {
                        //Set color name.
                        colorName = "green";
                        
                        //Set pen color.
                        p.setColor(colorName);
                        
                        break;
                    }
                        
                    //A pink pen.
                    case 'n':
                    {
                        //Set color name.
                        colorName = "pink";
                        
                        //Set pen color.
                        p.setColor(colorName);
                        
                        break;
                    }
                    
                    //An orange pen.
                    case 'o':
                    {
                        //Set color name.
                        colorName = "orange";
                        
                        //Set pen color.
                        p.setColor(colorName);
                        
                        break;
                    }
                        
                    //A pen of unknown color.
                    default:
                    {
                        //Output error message.
                        std::cerr << "I regret to inform you that ink is not available in that color. " << std::endl << std::endl;
                        
                        sleep(2);
                        
                        //Prompt to choose again.
                        std::cout << "Please choose a color from the list above." << std::endl << std::endl;
                        
                        break;
                    }
                }
                
                sleep(2);
                
                break;
            }
            
            //Remove pen cap.
            case 'm':
            {
                //Call to function removing pen cap.
                p.unCap();
               
                break;
            }
            
            //Replace pen cap.
            case 'p':
            {
                //Call to function replacing pen cap.
                p.reCap();
                
                break;
            }
                
            //Write.
            case 'w':
            {
                //If any property isn't specifed.
                if (!p.hasProperty('b') || !p.hasProperty('t') || !p.hasProperty('c'))
                {
                    std::cout << "You haven't finished choosing a pen. Please, allow me to recommend one for you. Shall we rectify this oversight? (y)es or (n)o?" << std::endl;
                    
                    //Accept character input for selection.
                    char isYorN = ' ';
                    
                    do {
                        std::cin >> isYorN;
                        
                        //Clear buffer.
                        std::cin.clear();
                        std::cin.ignore(INT_MAX, '\n');
                        
                        //Randomize any unspecified attributes.
                        if (isYorN == 'y' || isYorN == 'Y')
                        {
                            if (!p.hasProperty('b'))
                            {
                                p.randomPen('b');
                            }
                            if (!p.hasProperty('t'))
                            {
                                p.randomPen('t');
                            }
                            if (!p.hasProperty('c'))
                            {
                                p.randomPen('c');
                            }
                        }
                        //Disregard without randomizing and await further user commands.
                        else if (isYorN == 'n' || isYorN == 'N')
                        {
                            std::cout << "Well, never you mind then." << std::endl << std::endl;
                        }
                    //As long as user doesn't enter y, Y, n or N.
                    } while (isYorN != 'y' && isYorN != 'Y' && isYorN != 'n' && isYorN != 'N');
                }
                
                //Check if pen exists.
                if (p.doesPenExist())
                {
                    //Check if cap is on.
                    if (p.isCapOn())
                    {
                        //If cap is on, pass empty string.
                        p.write("");
                    }
                    //If cap is off, writing is possible..
                    else
                    {
                        //Prompt for string input from user.
                        std::cout << std::endl << "Fabulous! Please enter the message you wish me to write:" << std::endl;
                        
                        //Declare string variable to hold user input.
                        std::string message;
                        
                        //Accept user input of string, using getline in order to accept multiple words.
                        std::getline(std::cin, message);
                        
                        //Call to write function, passing user input as argument.
                        p.write(message);
                    }
                }
                else
                {
                    //Set to false to avoid displaying writing prompt.
                    understandCommand = false;

                    //std::cerr << "I regret to tell you that there is no such pen on record." << std::endl;
                }
                
                break;
            }
           
            //List options.
            case 'l':
            {
                std::cout << std::endl << "Again, I comprehend the following commands:" << std::endl << "* selecting the desired (b)rand, (t)ype and (c)olor of your ideal pen;" << std::endl << "* (d)escribing your pen; " << std::endl << "* re(m)oving or re(p)lacing the cap of your pen;" << std::endl << "* (w)riting with your pen;" << std::endl << "* (l)isting available commands;" << std::endl << "* creating a (n)ew pen;" << std::endl << "* (q)uitting the program." << std::endl << "For simplicity's sake, please type only the letter indicated to complete your request. " << std::endl << std::endl;
                
                break;
            }
            
            //Describe pen.
            case 'd':
            {
                //Call to function that describes current pen configuration.
                p.describePen();
            
                break;
            }
                
            //New pen.
            case 'n':
            {
                std::cout << "I will gladly create a new pen for you." << std::endl << std::endl;
                
                //Construct a new generic Pen object with no arguments, and set pointer to the newly constructed object.
                pointerP = new Pen();
                
                //Thanks again chapter 9!
                p = *pointerP;
                
                //Delete the pointer since the Pen object has been created.
                delete pointerP;
                
                break;
            }
            
            //Quit.
            case 'q':
            {
                //Call to quit function.
                p.quitPen();
                
                //Set to false to avoid displaying pen selection prompt.
                understandCommand = false;
                
                break;
            }
            
            //For any other character input.
            default:
            {
                //Set to false to avoid displaying pen selection prompt.
                understandCommand = false;
                
                //Output error message.
                std::cerr << std::endl << "My sincerest apologies. I am unable to understand your request. Please refer to the aforesaid commands for the extent of my abilities." << std::endl << std::endl;
                
                sleep(3);
                
                //Prompt to choose again.
                std::cout << "Please indicate another choice based on the commands I related above: ";
               
                break;
            }
        }
        
        //If command chosen is valid.
        if (understandCommand)
        {
            //If pen has all properties.
            if (p.hasProperty('b') && p.hasProperty('t') && p.hasProperty('c'))
            {
                //If pen cap is on.
                if (p.isCapOn())
                {
                    std::cout << "Shall we get on with it? Would you be interested in re(m)oving the cap of your pen and (w)riting with your pen? You may request a (l)ist of more commands as well, or (q)uit if you are finished using your humble letter-writer." << std::endl << std::endl;
                }
                //If pen cap is off.
                else if (!p.isCapOn())
                {
                    std::cout << "Shall we get on with it? Would you be interested in (w)riting with your pen or re(p)lacing the cap of your pen? You may request a (l)ist of more commands as well." << std::endl << std::endl;
                }
                
                sleep(2);
                
                std::cout << "Why, of course you would! Please do tell me your choice: ";
            }
            //Prompt to select pen properties if does not have already.
            else
            {
                std::cout << "Would you be interested in selecting a pen";
                if (!p.hasProperty('b'))
                {
                    std::cout << " (b)rand?";
                }
                if (!p.hasProperty('t'))
                {
                    std::cout << " (t)ype?";
                }
                if (!p.hasProperty('c'))
                {
                    std::cout << " (c)olor?";
                }
                
                //Await user input.
                std::cout << std::endl << std::endl << "Please indicate your choice: ";
            }
        }
    }
    
    return 0;
}


/*
 (W)rite a Letter
 Pen (C)olor
 Pen (B)rand
 Bic
 Montblanc
 Paper Mate
 Pentel
 Pilot
 Uni-ball
 Zebra
 Pen (T)ype
 Ballpoint
 Fountain
 Gel
 Rollerball
 
 (F)ont Style
 (C)ursive
 (D)igital
 (I)talics
 (P)rint
 (A)ll Caps
 (F)inish Letter
 (E)rase Letter
 (S)end Letter
 
 (A)ccess a Letter
 (S)elect Letter
 (S)ave Letter
 (D)elete Letter
 */


/*
 Pen p;                             // brand new pen made!
 
 p.setColor( "blue" );              // pen's color set to blue!
 p.setBrand( "Bic" );               // pen's brand set to Bic!
 
 p.unCap( );                        // pen's cap is now off!
 p.write( "hello" );                // blue Bic is writing hello!
 p.reCap( );                        // pen's cap is back on!
 
 // now let's get some errors...
 p.write( "hello world" );          // you can't write with this pen until the cap is off!
 
 p.unCap( );                        // pen's cap is now off!
 p.reCap( );                        // pen's cap is back on!
 p.write( "hello world" );          // you can't write with this pen until the cap is off!
*/